diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/test/wifi-retransmit-test.cc ns-3.45/src/wifi/test/wifi-retransmit-test.cc
--- ns-3.44/src/wifi/test/wifi-retransmit-test.cc	2025-03-09 16:55:49.811372800 -0700
+++ ns-3.45/src/wifi/test/wifi-retransmit-test.cc	2025-06-01 20:34:45.642702300 -0700
@@ -66,6 +66,11 @@
  *
  * In case of multi-link devices, the first TXOP is carried out on link 0 and the second TXOP on
  * link 1. It is checked that QSRC and CW are updated on the link on which the TXOP is carried out.
+ *
+ * The TX width of transmitted frames is also checked, considering that the AP operates on a
+ * 160 MHz channel and the non-AP STA does not support 160 MHz operations (hence the AP will use
+ * its primary80 channel to transmit to the non-AP STA). In case of multi-link devices, the second
+ * link is operated on a 40 MHz channel.
  */
 class WifiRetransmitTest : public TestCase
 {
@@ -190,12 +195,12 @@
 
     SpectrumWifiPhyHelper phy(m_nLinks);
     phy.SetChannel(CreateObject<MultiModelSpectrumChannel>());
-    // use default 20 MHz channel in 5 GHz band
-    phy.Set(0, "ChannelSettings", StringValue("{0, 20, BAND_5GHZ, 0}"));
+    // use default 80 MHz channel in 5 GHz band for the non-AP STA
+    phy.Set(0, "ChannelSettings", StringValue("{0, 80, BAND_5GHZ, 0}"));
     if (m_nLinks > 1)
     {
-        // use default 20 MHz channel in 6 GHz band
-        phy.Set(1, "ChannelSettings", StringValue("{0, 20, BAND_6GHZ, 0}"));
+        // use default 40 MHz channel in 6 GHz band
+        phy.Set(1, "ChannelSettings", StringValue("{0, 40, BAND_6GHZ, 0}"));
     }
 
     Config::SetDefault("ns3::WifiRemoteStationManager::RtsCtsThreshold",
@@ -221,6 +226,9 @@
     NetDeviceContainer staDevice = wifi.Install(phy, mac, wifiStaNode);
     m_staMac = StaticCast<StaWifiMac>(StaticCast<WifiNetDevice>(staDevice.Get(0))->GetMac());
 
+    // use default 160 MHz channel in 5 GHz band for the AP
+    phy.Set(0, "ChannelSettings", StringValue("{0, 160, BAND_5GHZ, 0}"));
+
     mac.SetType("ns3::ApWifiMac");
     mac.SetEdca(AC_BE,
                 "TxopLimits",
@@ -383,6 +391,16 @@
         return;
     }
 
+    // check width of transmitted frames, except CTS because we do not support yet static/dynamic
+    // bandwidth operation
+    const auto expectedWidth = (phyId == 0 ? 80 : 40);
+    if (!hdr.IsCts())
+    {
+        NS_TEST_EXPECT_MSG_EQ(txVector.GetChannelWidth(),
+                              expectedWidth,
+                              "Unexpected width for " << hdr.GetTypeString());
+    }
+
     if (m_eventIt != m_events.cend())
     {
         // check that the expected frame is being transmitted
@@ -654,7 +672,7 @@
                         m_staMac->GetDevice()->GetNode(),
                         GetApplication(2, m_pktSize));
 
-    Simulator::Stop(Seconds(1));
+    Simulator::Stop(Seconds(0.550));
     Simulator::Run();
 
     NS_TEST_EXPECT_MSG_EQ((m_eventIt == m_events.cend()), true, "Not all events took place");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/test/wifi-ru-allocation-test.cc ns-3.45/src/wifi/test/wifi-ru-allocation-test.cc
--- ns-3.44/src/wifi/test/wifi-ru-allocation-test.cc	2025-03-09 16:55:49.811372800 -0700
+++ ns-3.45/src/wifi/test/wifi-ru-allocation-test.cc	2025-06-01 20:34:45.643702300 -0700
@@ -8,11 +8,42 @@
 
 #include "ns3/test.h"
 #include "ns3/wifi-phy-operating-channel.h"
+#include "ns3/wifi-ru.h"
+#include "ns3/wifi-utils.h"
 
 using namespace ns3;
 
 NS_LOG_COMPONENT_DEFINE("WifiRuAllocationTest");
 
+namespace
+{
+/**
+ * Create an HE or an EHT RU Specification.
+ * If a primary80 is provided, an HE RU Specification is created, other it is an EHT RU
+ * Specification.
+ *
+ * @param ruType the RU type
+ * @param index the RU index (starting at 1)
+ * @param primaryOrLow80MHz whether the RU is allocated in the primary 80MHz channel or in the low
+ * 80 MHz if the RU is allocated in the secondary 160 MHz
+ * @param primary160MHz whether the RU is allocated in the primary 160MHz channel (only for EHT)
+ * @return the created RU Specification.
+ */
+WifiRu::RuSpec
+MakeRuSpec(RuType ruType,
+           std::size_t index,
+           bool primaryOrLow80MHz,
+           std::optional<bool> primary160MHz = std::nullopt)
+{
+    if (!primary160MHz)
+    {
+        return HeRu::RuSpec{ruType, index, primaryOrLow80MHz};
+    }
+    return EhtRu::RuSpec{ruType, index, *primary160MHz, primaryOrLow80MHz};
+}
+
+} // namespace
+
 /**
  * @ingroup wifi-test
  * @ingroup tests
@@ -24,8 +55,9 @@
   public:
     /**
      * Constructor
+     * @param standard the standard to use for the test
      */
-    Wifi20MHzIndicesCoveringRuTest();
+    Wifi20MHzIndicesCoveringRuTest(WifiStandard standard);
     ~Wifi20MHzIndicesCoveringRuTest() override = default;
 
     /**
@@ -35,24 +67,31 @@
      * @param primary20 the index of the primary20 channel to configure
      * @param ru the given RU
      * @param width the width of the channel to which the given RU refers to; normally, it is the
-     * width of the PPDU for which the RU is allocated \param indices the expected indices
+     * width of the PPDU for which the RU is allocated
+     * @param indices the expected indices
      */
-    void RunOne(uint8_t primary20, HeRu::RuSpec ru, MHz_u width, const std::set<uint8_t>& indices);
+    void RunOne(uint8_t primary20,
+                WifiRu::RuSpec ru,
+                MHz_u width,
+                const std::set<uint8_t>& indices);
 
   private:
     void DoRun() override;
 
+    WifiStandard m_standard;           ///< The standard to use for the test
     WifiPhyOperatingChannel m_channel; //!< operating channel
 };
 
-Wifi20MHzIndicesCoveringRuTest::Wifi20MHzIndicesCoveringRuTest()
-    : TestCase("Check computation of the indices of the 20 MHz channels covering an RU")
+Wifi20MHzIndicesCoveringRuTest::Wifi20MHzIndicesCoveringRuTest(WifiStandard standard)
+    : TestCase("Check computation of the indices of the 20 MHz channels covering an RU for " +
+               std::string((standard == WIFI_STANDARD_80211ax) ? "11ax" : "11be")),
+      m_standard(standard)
 {
 }
 
 void
 Wifi20MHzIndicesCoveringRuTest::RunOne(uint8_t primary20,
-                                       HeRu::RuSpec ru,
+                                       WifiRu::RuSpec ru,
                                        MHz_u width,
                                        const std::set<uint8_t>& indices)
 {
@@ -68,12 +107,11 @@
     };
 
     m_channel.SetPrimary20Index(primary20);
-
     auto actualIndices = m_channel.Get20MHzIndicesCoveringRu(ru, width);
-    NS_TEST_ASSERT_MSG_EQ((actualIndices == indices),
+    NS_TEST_EXPECT_MSG_EQ((actualIndices == indices),
                           true,
-                          "Channel width=" << m_channel.GetWidth() << " MHz, PPDU width=" << width
-                                           << " MHz, p20Index=" << +primary20 << " , RU=" << ru
+                          "Channel width=" << m_channel.GetWidth() << ", PPDU width=" << width
+                                           << ", p20Index=" << +primary20 << " , RU=" << ru
                                            << ". Expected indices " << printToStr(indices)
                                            << " differs from actual " << printToStr(actualIndices));
 }
@@ -81,10 +119,13 @@
 void
 Wifi20MHzIndicesCoveringRuTest::DoRun()
 {
+    const auto p80{true};
+    const auto p160{(m_standard == WIFI_STANDARD_80211be) ? std::optional(true) : std::nullopt};
+
     /******************
      * 20 MHz channel *
      ******************/
-    m_channel.SetDefault(MHz_u{20}, WIFI_STANDARD_80211ax, WIFI_PHY_BAND_5GHZ);
+    m_channel.SetDefault(MHz_u{20}, m_standard, WIFI_PHY_BAND_6GHZ);
 
     /* 20 MHz PPDU */
     {
@@ -94,26 +135,26 @@
         // All the 9 26-tone RUs are covered by the unique 20 MHz channel
         for (std::size_t idx = 1; idx <= 9; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_26_TONE, idx, true), width, {p20Index});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_26_TONE, idx, p80, p160), width, {p20Index});
         }
         // All the 4 52-tone RUs are covered by the unique 20 MHz channel
         for (std::size_t idx = 1; idx <= 4; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_52_TONE, idx, true), width, {p20Index});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_52_TONE, idx, p80, p160), width, {p20Index});
         }
         // Both 106-tone RUs are covered by the unique 20 MHz channel
         for (std::size_t idx = 1; idx <= 2; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_106_TONE, idx, true), width, {p20Index});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_106_TONE, idx, p80, p160), width, {p20Index});
         }
         // The 242-tone RU is covered by the unique 20 MHz channel
-        RunOne(p20Index, HeRu::RuSpec(HeRu::RU_242_TONE, 1, true), width, {p20Index});
+        RunOne(p20Index, MakeRuSpec(RuType::RU_242_TONE, 1, p80, p160), width, {p20Index});
     }
 
     /******************
      * 40 MHz channel *
      ******************/
-    m_channel.SetDefault(MHz_u{40}, WIFI_STANDARD_80211ax, WIFI_PHY_BAND_5GHZ);
+    m_channel.SetDefault(MHz_u{40}, m_standard, WIFI_PHY_BAND_6GHZ);
 
     /* 20 MHz PPDU */
     for (uint8_t p20Index = 0; p20Index < 2; p20Index++)
@@ -123,20 +164,20 @@
         // All the 9 26-tone RUs are covered by the primary 20 MHz channel
         for (std::size_t idx = 1; idx <= 9; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_26_TONE, idx, true), width, {p20Index});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_26_TONE, idx, p80, p160), width, {p20Index});
         }
         // All the 4 52-tone RUs are covered by the primary 20 MHz channel
         for (std::size_t idx = 1; idx <= 4; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_52_TONE, idx, true), width, {p20Index});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_52_TONE, idx, p80, p160), width, {p20Index});
         }
         // Both 106-tone RUs are covered by the primary 20 MHz channel
         for (std::size_t idx = 1; idx <= 2; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_106_TONE, idx, true), width, {p20Index});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_106_TONE, idx, p80, p160), width, {p20Index});
         }
         // The 242-tone RU is covered by the primary 20 MHz channel
-        RunOne(p20Index, HeRu::RuSpec(HeRu::RU_242_TONE, 1, true), width, {p20Index});
+        RunOne(p20Index, MakeRuSpec(RuType::RU_242_TONE, 1, p80, p160), width, {p20Index});
     }
 
     /* 40 MHz PPDU */
@@ -147,45 +188,45 @@
         // The first 9 26-tone RUs are covered by the first 20 MHz channel
         for (std::size_t idx = 1; idx <= 9; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_26_TONE, idx, true), width, {0});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_26_TONE, idx, p80, p160), width, {0});
         }
         // The second 9 26-tone RUs are covered by the second 20 MHz channel
         for (std::size_t idx = 10; idx <= 18; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_26_TONE, idx, true), width, {1});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_26_TONE, idx, p80, p160), width, {1});
         }
         // The first 4 52-tone RUs are covered by the first 20 MHz channel
         for (std::size_t idx = 1; idx <= 4; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_52_TONE, idx, true), width, {0});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_52_TONE, idx, p80, p160), width, {0});
         }
         // The second 4 52-tone RUs are covered by the second 20 MHz channel
         for (std::size_t idx = 5; idx <= 8; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_52_TONE, idx, true), width, {1});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_52_TONE, idx, p80, p160), width, {1});
         }
         // The first 2 106-tone RUs are covered by the first 20 MHz channel
         for (std::size_t idx = 1; idx <= 2; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_106_TONE, idx, true), width, {0});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_106_TONE, idx, p80, p160), width, {0});
         }
         // The second 2 106-tone RUs are covered by the second 20 MHz channel
         for (std::size_t idx = 3; idx <= 4; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_106_TONE, idx, true), width, {1});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_106_TONE, idx, p80, p160), width, {1});
         }
         // The first 242-tone RU is covered by the first 20 MHz channel
-        RunOne(p20Index, HeRu::RuSpec(HeRu::RU_242_TONE, 1, true), width, {0});
+        RunOne(p20Index, MakeRuSpec(RuType::RU_242_TONE, 1, p80, p160), width, {0});
         // The second 242-tone RU is covered by the second 20 MHz channel
-        RunOne(p20Index, HeRu::RuSpec(HeRu::RU_242_TONE, 2, true), width, {1});
+        RunOne(p20Index, MakeRuSpec(RuType::RU_242_TONE, 2, p80, p160), width, {1});
         // The 484-tone RU is covered by both 20 MHz channels
-        RunOne(p20Index, HeRu::RuSpec(HeRu::RU_484_TONE, 1, true), width, {0, 1});
+        RunOne(p20Index, MakeRuSpec(RuType::RU_484_TONE, 1, p80, p160), width, {0, 1});
     }
 
     /******************
      * 80 MHz channel *
      ******************/
-    m_channel.SetDefault(MHz_u{80}, WIFI_STANDARD_80211ax, WIFI_PHY_BAND_5GHZ);
+    m_channel.SetDefault(MHz_u{80}, m_standard, WIFI_PHY_BAND_6GHZ);
 
     /* 20 MHz PPDU */
     for (uint8_t p20Index = 0; p20Index < 4; p20Index++)
@@ -195,20 +236,20 @@
         // All the 9 26-tone RUs are covered by the primary 20 MHz channel
         for (std::size_t idx = 1; idx <= 9; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_26_TONE, idx, true), width, {p20Index});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_26_TONE, idx, p80, p160), width, {p20Index});
         }
         // All the 4 52-tone RUs are covered by the primary 20 MHz channel
         for (std::size_t idx = 1; idx <= 4; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_52_TONE, idx, true), width, {p20Index});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_52_TONE, idx, p80, p160), width, {p20Index});
         }
         // Both 106-tone RUs are covered by the primary 20 MHz channel
         for (std::size_t idx = 1; idx <= 2; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_106_TONE, idx, true), width, {p20Index});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_106_TONE, idx, p80, p160), width, {p20Index});
         }
         // The 242-tone RU is covered by the primary 20 MHz channel
-        RunOne(p20Index, HeRu::RuSpec(HeRu::RU_242_TONE, 1, true), width, {p20Index});
+        RunOne(p20Index, MakeRuSpec(RuType::RU_242_TONE, 1, p80, p160), width, {p20Index});
     }
 
     /* 40 MHz PPDU */
@@ -224,39 +265,42 @@
         // The first 9 26-tone RUs are in the lower 20 MHz of the PPDU bandwidth
         for (std::size_t idx = 1; idx <= 9; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_26_TONE, idx, true), width, {ch20Index0});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_26_TONE, idx, p80, p160), width, {ch20Index0});
         }
         // The second 9 26-tone RUs are in the higher 20 MHz of the PPDU bandwidth
         for (std::size_t idx = 10; idx <= 18; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_26_TONE, idx, true), width, {ch20Index1});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_26_TONE, idx, p80, p160), width, {ch20Index1});
         }
         // The first 4 52-tone RUs are in the lower 20 MHz of the PPDU bandwidth
         for (std::size_t idx = 1; idx <= 4; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_52_TONE, idx, true), width, {ch20Index0});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_52_TONE, idx, p80, p160), width, {ch20Index0});
         }
         // The second 4 52-tone RUs are in the higher 20 MHz of the PPDU bandwidth
         for (std::size_t idx = 5; idx <= 8; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_52_TONE, idx, true), width, {ch20Index1});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_52_TONE, idx, p80, p160), width, {ch20Index1});
         }
         // The first 2 106-tone RUs are in the lower 20 MHz of the PPDU bandwidth
         for (std::size_t idx = 1; idx <= 2; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_106_TONE, idx, true), width, {ch20Index0});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_106_TONE, idx, p80, p160), width, {ch20Index0});
         }
         // The second 2 106-tone RUs are in the higher 20 MHz of the PPDU bandwidth
         for (std::size_t idx = 3; idx <= 4; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_106_TONE, idx, true), width, {ch20Index1});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_106_TONE, idx, p80, p160), width, {ch20Index1});
         }
         // The first 242-tone RU is in the lower 20 MHz of the PPDU bandwidth
-        RunOne(p20Index, HeRu::RuSpec(HeRu::RU_242_TONE, 1, true), width, {ch20Index0});
+        RunOne(p20Index, MakeRuSpec(RuType::RU_242_TONE, 1, p80, p160), width, {ch20Index0});
         // The second 242-tone RU is in the higher 20 MHz of the PPDU bandwidth
-        RunOne(p20Index, HeRu::RuSpec(HeRu::RU_242_TONE, 2, true), width, {ch20Index1});
+        RunOne(p20Index, MakeRuSpec(RuType::RU_242_TONE, 2, p80, p160), width, {ch20Index1});
         // The 484-tone RU is covered by both 20 MHz channels
-        RunOne(p20Index, HeRu::RuSpec(HeRu::RU_484_TONE, 1, true), width, {ch20Index0, ch20Index1});
+        RunOne(p20Index,
+               MakeRuSpec(RuType::RU_484_TONE, 1, p80, p160),
+               width,
+               {ch20Index0, ch20Index1});
     }
 
     /* 80 MHz PPDU */
@@ -267,85 +311,88 @@
         // The first 9 26-tone RUs are in the first 20 MHz channel
         for (std::size_t idx = 1; idx <= 9; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_26_TONE, idx, true), width, {0});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_26_TONE, idx, p80, p160), width, {0});
         }
         // The second 9 26-tone RUs are in the second 20 MHz channel
         for (std::size_t idx = 10; idx <= 18; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_26_TONE, idx, true), width, {1});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_26_TONE, idx, p80, p160), width, {1});
+        }
+        if (m_standard == WIFI_STANDARD_80211ax)
+        {
+            // The center 26-tone RU is covered by the central 20 MHz channels
+            RunOne(p20Index, MakeRuSpec(RuType::RU_26_TONE, 19, p80, p160), width, {1, 2});
         }
-        // The center 26-tone RU is covered by the central 20 MHz channels
-        RunOne(p20Index, HeRu::RuSpec(HeRu::RU_26_TONE, 19, true), width, {1, 2});
         // The following 9 26-tone RUs are in the third 20 MHz channel
         for (std::size_t idx = 20; idx <= 28; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_26_TONE, idx, true), width, {2});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_26_TONE, idx, p80, p160), width, {2});
         }
         // The last 9 26-tone RUs are in the fourth 20 MHz channel
         for (std::size_t idx = 29; idx <= 37; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_26_TONE, idx, true), width, {3});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_26_TONE, idx, p80, p160), width, {3});
         }
         // The first 4 52-tone RUs are in the first 20 MHz channel
         for (std::size_t idx = 1; idx <= 4; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_52_TONE, idx, true), width, {0});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_52_TONE, idx, p80, p160), width, {0});
         }
         // The second 4 52-tone RUs are in the second 20 MHz channel
         for (std::size_t idx = 5; idx <= 8; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_52_TONE, idx, true), width, {1});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_52_TONE, idx, p80, p160), width, {1});
         }
         // The third 4 52-tone RUs are in the third 20 MHz channel
         for (std::size_t idx = 9; idx <= 12; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_52_TONE, idx, true), width, {2});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_52_TONE, idx, p80, p160), width, {2});
         }
         // The fourth 4 52-tone RUs are in the fourth 20 MHz channel
         for (std::size_t idx = 13; idx <= 16; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_52_TONE, idx, true), width, {3});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_52_TONE, idx, p80, p160), width, {3});
         }
         // The first 2 106-tone RUs are in the first 20 MHz channel
         for (std::size_t idx = 1; idx <= 2; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_106_TONE, idx, true), width, {0});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_106_TONE, idx, p80, p160), width, {0});
         }
         // The second 2 106-tone RUs are in the second 20 MHz channel
         for (std::size_t idx = 3; idx <= 4; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_106_TONE, idx, true), width, {1});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_106_TONE, idx, p80, p160), width, {1});
         }
         // The third 2 106-tone RUs are in the third 20 MHz channel
         for (std::size_t idx = 5; idx <= 6; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_106_TONE, idx, true), width, {2});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_106_TONE, idx, p80, p160), width, {2});
         }
         // The fourth 2 106-tone RUs are in the fourth 20 MHz channel
         for (std::size_t idx = 7; idx <= 8; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_106_TONE, idx, true), width, {3});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_106_TONE, idx, p80, p160), width, {3});
         }
         // The first 242-tone RU is in the first 20 MHz channel
-        RunOne(p20Index, HeRu::RuSpec(HeRu::RU_242_TONE, 1, true), width, {0});
+        RunOne(p20Index, MakeRuSpec(RuType::RU_242_TONE, 1, p80, p160), width, {0});
         // The second 242-tone RU is in the second 20 MHz channel
-        RunOne(p20Index, HeRu::RuSpec(HeRu::RU_242_TONE, 2, true), width, {1});
+        RunOne(p20Index, MakeRuSpec(RuType::RU_242_TONE, 2, p80, p160), width, {1});
         // The third 242-tone RU is in the third 20 MHz channel
-        RunOne(p20Index, HeRu::RuSpec(HeRu::RU_242_TONE, 3, true), width, {2});
+        RunOne(p20Index, MakeRuSpec(RuType::RU_242_TONE, 3, p80, p160), width, {2});
         // The fourth 242-tone RU is in the fourth 20 MHz channel
-        RunOne(p20Index, HeRu::RuSpec(HeRu::RU_242_TONE, 4, true), width, {3});
+        RunOne(p20Index, MakeRuSpec(RuType::RU_242_TONE, 4, p80, p160), width, {3});
         // The first 484-tone RU is covered by the first two 20 MHz channels
-        RunOne(p20Index, HeRu::RuSpec(HeRu::RU_484_TONE, 1, true), width, {0, 1});
+        RunOne(p20Index, MakeRuSpec(RuType::RU_484_TONE, 1, p80, p160), width, {0, 1});
         // The second 484-tone RU is covered by the last two 20 MHz channels
-        RunOne(p20Index, HeRu::RuSpec(HeRu::RU_484_TONE, 2, true), width, {2, 3});
+        RunOne(p20Index, MakeRuSpec(RuType::RU_484_TONE, 2, p80, p160), width, {2, 3});
         // The 996-tone RU is covered by all the 20 MHz channels
-        RunOne(p20Index, HeRu::RuSpec(HeRu::RU_996_TONE, 1, true), width, {0, 1, 2, 3});
+        RunOne(p20Index, MakeRuSpec(RuType::RU_996_TONE, 1, p80, p160), width, {0, 1, 2, 3});
     }
 
     /******************
      * 160 MHz channel *
      ******************/
-    m_channel.SetDefault(MHz_u{160}, WIFI_STANDARD_80211ax, WIFI_PHY_BAND_5GHZ);
+    m_channel.SetDefault(MHz_u{160}, m_standard, WIFI_PHY_BAND_6GHZ);
 
     /* 20 MHz PPDU */
     for (uint8_t p20Index = 0; p20Index < 8; p20Index++)
@@ -355,20 +402,20 @@
         // All the 9 26-tone RUs are covered by the primary 20 MHz channel
         for (std::size_t idx = 1; idx <= 9; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_26_TONE, idx, true), width, {p20Index});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_26_TONE, idx, p80, p160), width, {p20Index});
         }
         // All the 4 52-tone RUs are covered by the primary 20 MHz channel
         for (std::size_t idx = 1; idx <= 4; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_52_TONE, idx, true), width, {p20Index});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_52_TONE, idx, p80, p160), width, {p20Index});
         }
         // Both 106-tone RUs are covered by the primary 20 MHz channel
         for (std::size_t idx = 1; idx <= 2; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_106_TONE, idx, true), width, {p20Index});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_106_TONE, idx, p80, p160), width, {p20Index});
         }
         // The 242-tone RU is covered by the primary 20 MHz channel
-        RunOne(p20Index, HeRu::RuSpec(HeRu::RU_242_TONE, 1, true), width, {p20Index});
+        RunOne(p20Index, MakeRuSpec(RuType::RU_242_TONE, 1, p80, p160), width, {p20Index});
     }
 
     /* 40 MHz PPDU */
@@ -384,39 +431,42 @@
         // The first 9 26-tone RUs are in the lower 20 MHz of the PPDU bandwidth
         for (std::size_t idx = 1; idx <= 9; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_26_TONE, idx, true), width, {ch20Index0});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_26_TONE, idx, p80, p160), width, {ch20Index0});
         }
         // The second 9 26-tone RUs are in the higher 20 MHz of the PPDU bandwidth
         for (std::size_t idx = 10; idx <= 18; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_26_TONE, idx, true), width, {ch20Index1});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_26_TONE, idx, p80, p160), width, {ch20Index1});
         }
         // The first 4 52-tone RUs are in the lower 20 MHz of the PPDU bandwidth
         for (std::size_t idx = 1; idx <= 4; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_52_TONE, idx, true), width, {ch20Index0});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_52_TONE, idx, p80, p160), width, {ch20Index0});
         }
         // The second 4 52-tone RUs are in the higher 20 MHz of the PPDU bandwidth
         for (std::size_t idx = 5; idx <= 8; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_52_TONE, idx, true), width, {ch20Index1});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_52_TONE, idx, p80, p160), width, {ch20Index1});
         }
         // The first 2 106-tone RUs are in the lower 20 MHz of the PPDU bandwidth
         for (std::size_t idx = 1; idx <= 2; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_106_TONE, idx, true), width, {ch20Index0});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_106_TONE, idx, p80, p160), width, {ch20Index0});
         }
         // The second 2 106-tone RUs are in the higher 20 MHz of the PPDU bandwidth
         for (std::size_t idx = 3; idx <= 4; idx++)
         {
-            RunOne(p20Index, HeRu::RuSpec(HeRu::RU_106_TONE, idx, true), width, {ch20Index1});
+            RunOne(p20Index, MakeRuSpec(RuType::RU_106_TONE, idx, p80, p160), width, {ch20Index1});
         }
         // The first 242-tone RU is in the lower 20 MHz of the PPDU bandwidth
-        RunOne(p20Index, HeRu::RuSpec(HeRu::RU_242_TONE, 1, true), width, {ch20Index0});
+        RunOne(p20Index, MakeRuSpec(RuType::RU_242_TONE, 1, p80, p160), width, {ch20Index0});
         // The second 242-tone RU is in the higher 20 MHz of the PPDU bandwidth
-        RunOne(p20Index, HeRu::RuSpec(HeRu::RU_242_TONE, 2, true), width, {ch20Index1});
+        RunOne(p20Index, MakeRuSpec(RuType::RU_242_TONE, 2, p80, p160), width, {ch20Index1});
         // The 484-tone RU is covered by both 20 MHz channels
-        RunOne(p20Index, HeRu::RuSpec(HeRu::RU_484_TONE, 1, true), width, {ch20Index0, ch20Index1});
+        RunOne(p20Index,
+               MakeRuSpec(RuType::RU_484_TONE, 1, p80, p160),
+               width,
+               {ch20Index0, ch20Index1});
     }
 
     /* 80 MHz PPDU */
